-- Copyright (c) 2024 Huawei Technologies Co., Ltd.
-- openUBMC is licensed under Mulan PSL v2.
-- You can use this software according to the terms and conditions of the Mulan PSL v2.
-- You may obtain a copy of Mulan PSL v2 at:
--         http://license.coscl.org.cn/MulanPSL2
-- THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
-- EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
-- MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
-- See the Mulan PSL v2 for more details.

local BlockIOInterface = require 'mdb.bmc.kepler.Chip.BlockIOInterface'
local ChipInterface = require 'mdb.bmc.kepler.ChipInterface'
local JtagTargetInterface = require 'mdb.bmc.kepler.Chip.JtagTargetInterface'

local childs = {}
local Cpld = {childs = childs}

local Mdb = require 'mc.mdb'

local TCpld = Mdb.register_object('/bmc/kepler/Chip/Cpld/:Id', {
    {name = 'BlockIO', interface = BlockIOInterface.BlockIO},
    {name = 'Chip', interface = ChipInterface.Chip},
    {name = 'JtagTarget', interface = JtagTargetInterface.JtagTarget}
})
Cpld.Cpld = TCpld

function TCpld:ctor(Id)
    self.path = '/bmc/kepler/Chip/Cpld/' .. Id .. ''
end

return Cpld
